package com.example.backend.users.model;

import java.util.Objects;

import com.example.backend.core.model.BaseEntity;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.Table;

@Entity
@Table(name = "users")
public class UserEntity extends BaseEntity {

    @Column(nullable = false, unique = true, length = 15)
    private String username;

    @Column(nullable = false, length = 5)
    private String password;

    private UserRole role;

    public UserEntity() {

    }

    public UserEntity(Integer id, String username, String password) {
        this.username = username;
        this.password = password;
        this.role = UserRole.USER;
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public UserRole getRole() {
        return role;
    }

    public void setRole(UserRole role) {
        this.role = role;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, username, password, role);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final UserEntity other = (UserEntity) obj;
        return Objects.equals(other.getId(), id) &&
                Objects.equals(other.getUsername(), username) &&
                Objects.equals(other.getRole(), role) &&
                Objects.equals(other.getPassword(), password);
    }
}
